var Scan = function(stage, options) {
  this.stage = stage;
  this.options = options || {};
  this.color = this.options.color || "red";
  this.init();
};

Scan.prototype.init = function() {
  this.graphics = new createjs.Graphics();
  this.stage.addChild(new createjs.Shape(this.graphics));
};
/**
 * 
 * angle_increment: -0.004363323096185923
angle_max: -2.696533679962158
angle_min: 2.696533679962158
header: Object
intensities: Array(1237)
range_max: 25
range_min: 0
ranges: Array(1237)
scan_time: 0.09756970405578613
time_increment: 0.00006775673682568595
 */

Scan.prototype.draw = function(ressolution, scanData) {
  var self = this;
  this.scanData = scanData;
  this.graphics.c();
  this.graphics.setStrokeStyle(1);
  this.graphics.beginStroke("green");
  this.graphics.arc(300, 300, 1, Math.PI * 2, false);
  this.graphics.endStroke();
  var r =
    (this.scanData.angle_max - this.scanData.angle_min) /
    (this.scanData.ranges.length - 1);
  var type = this.scanData.angle_min * this.scanData.angle_max;
  var middle = parseInt(this.scanData.ranges.length / 2, 10);
  $.each(this.scanData.ranges, function (i, v) {
    // i为索引
    // v代表当前项
    if (v) {
      var c = v / ressolution;
      var ca, b, a, x, y;
      if (middle > i) {

        if ((middle - i) * r > 0.5 * Math.PI) {
          // 第三象限
          ca = Math.cos(Math.PI - (middle - i) * r);
          b = ca * c;
          a = Math.sqrt(Math.pow(c, 2) - Math.pow(b, 2));
          if (type >= 0) {
            x = -b;
          }
          if (type < 0) {
            x = b;
          }
          y = a;
        } else {
          // 第四象限
          ca = Math.cos((middle - i) * r);
          b = ca * c;
          a = Math.sqrt(Math.pow(c, 2) - Math.pow(b, 2));
          if (type >= 0) {
            x = b;
          }
          if (type < 0) {
            x = -b;
          }
          y = a;
        }
      } else {
        if ((i - middle) * r > 0.5 * Math.PI) {
          // 第二象限
          ca = Math.cos(Math.PI - (i - middle) * r);
          b = ca * c;
          a = Math.sqrt(Math.pow(c, 2) - Math.pow(b, 2));
          if (type >= 0) {
            x = -b;
          }
          if (type < 0) {
            x = b;
          }
          y = -a;
        } else {
          // 第一象限
          ca = Math.cos((i - middle) * r);
          b = ca * c;
          a = Math.sqrt(Math.pow(c, 2) - Math.pow(b, 2));
          if (type >= 0) {
            x = b;
          }
          if (type < 0) {
            x = -b;
          }
          y = -a;
        }
      }
      self.graphics.beginFill(self.color);
      self.graphics.arc(300 - x, 300 - y, 1, 0, Math.PI * 2, true);
      self.graphics.endFill();
      self.graphics.closePath();
    }
  });
};
